/*	
 *	clipmidi.h
 *
 *	P/ECE MIDI Driver
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Tue Aug 30 22:28:00 JST 2003 Naoyuki Sawa
 *	- VK쐬B
 *	* Tue Sep 02 24:00:00 JST 2003 Naoyuki Sawa
 *	- F}bvΉB
 *	- Yp[gΉB
 *	- `laΉB
 */
#ifndef __CLIP_MIDI_H__
#define __CLIP_MIDI_H__

/****************************************************************************
 *	萔E^`
 ****************************************************************************/

#define MIDITRACKS	16		/* T|[gőgbN() */

/* F}bv\(AvP[Vw) */
typedef struct _MIDIMAP {
	unsigned char melody[128];	/* fB[F}bv(MIDIvONo.(0`127)MODTvNo.(1`32A0͖)) */
	unsigned char rhythm[128];	/* YF}bv(MIDIm[gNo.(0`127)MODTvNo.(1`32A0͖)) */
} MIDIMAP;

/* MIDIgbN\(gp) */
typedef struct _MIDITRACK {
	const unsigned char* pos;	/* tʒu */
	int delta;			/* f^^C */
	int elapse;			/* CxgpJE^ */
	int running_status;		/* jOXe[^X */
} MIDITRACK;

/* MIDI`l\(gp) */
typedef struct _MIDICHANNEL {
	int program;			/* vOio[ */
} MIDICHANNEL;

/* MOD`lǗ\(gp) */
typedef struct _MIDIVOICE {
	int age;			/* 0:~/1`:(͖+1) */
	int channel;			/* MIDI`l */
	int note;			/* m[gio[ */
} MIDIVOICE;

/* MIDIhCo\(gp) */
typedef struct _MIDIDRIVER {
	const MIDIMAP* map;		/* F}bv */
	int track_count;		/* gbN */
	int time_unit;			/* ԒP(l̃f^^C) */
	int tempo;			/* e|(l̃}CNb) */
	MIDITRACK track[MIDITRACKS];	/* gbN */
	MIDICHANNEL channel[16];	/* `l */
	MIDIVOICE voice[MODCHANS];	/* MOD`lǗ */
	MODDRIVER mod;			/* MODhCo(Ƃėp) */
} MIDIDRIVER;

/****************************************************************************
 *	֐
 ****************************************************************************/

/* x֐(TODO:) */
int midi_play(const void* data, const void* inst, const MIDIMAP* map);
void midi_stop();

/* x֐(TODO:) */
int midi_init(MIDIDRIVER* driver, const void* data, const void* inst, const MIDIMAP* map);
int midi_tick(MIDIDRIVER* driver, short wbuff[/*MODBUFLEN*/]);

/* ჌x֐(TODO:) */
int midi_seq(MIDIDRIVER* driver);
int midi_mix(MIDIDRIVER* driver, short wbuff[/*MODBUFLEN*/]);

#endif /*__CLIP_MIDI_H__*/
